#IF 0  ' 

    LOCAL slen as DWORD
    LOCAL wlen as DWORD

    Open "yourfile.ext" for Binary as #1
      slen = lof(1)                             ' get the file length
      Get$ #1, slen, src$                       ' load file data into string
    Close #1

    dbdata$ = bin2db(src$)                      ' convert binary string to DB string
    wlen = len(dbdata$)                         ' get the written length if required

#ENDIF ' 

FUNCTION bin2db(src$) as STRING

    LOCAL psrc as DWORD
    LOCAL pdst as DWORD
    LOCAL flen as DWORD
    LOCAL wlen as DWORD

    flen = len(src$)
    dst$ = string$(flen * 12,chr$(0))           ' allocate a buffer for the result
    psrc = StrPtr(src$)
    pdst = StrPtr(dst$)

    AsciiDump psrc,pdst,flen                    ' convert the byte data to a DB string
    wlen = dbcompact(pdst)                      ' compact the spaces and return written length

    dst$ = left$(dst$,wlen)                     ' truncate string to end of data
    Replace "db" with "    ! db" in dst$        ' convert from MASM to PB format

    FUNCTION = dst$

End FUNCTION

' 

FUNCTION AsciiDump(ByVal lpsrc as DWORD,ByVal lpbuf as DWORD,ByVal lnsrc as DWORD) as DWORD

    #REGISTER NONE

    ! mov edx, OFFSET StringTable
    ! xor ebx, ebx                    ' line length counter

    ! mov ecx, lpsrc
    ! add ecx, lnsrc

    ! mov esi, lpsrc
    ! mov edi, lpbuf

    ! mov DWORD PTR [edi], &H0D202020 ' 3 space padding for alignment + CR
    ! add edi, 4
    ! mov DWORD PTR [edi], &H2062640A ' LF + "db "
    ! add edi, 4

    ! jmp adst

' ====================================

  #align 16
  pre:
    ! mov BYTE PTR [edi-1], 13        ' overwrite comma with CR
    ! mov DWORD PTR [edi], &H2062640A ' write 4 bytes to maintain alignment
    ! add edi, 4
    ! xor ebx, ebx                    ' zero character count
  adst:
    ! movzx eax, BYTE PTR [esi]
    ! add esi, 1
    ! cmp esi, ecx                    ' test exit condition
    ! jg trimit
    ! mov eax, [edx+eax*4]
    ! mov [edi], eax
    ! add edi, 4

    ! cmp ebx, 15                     ' test character count per line
    ! je pre                          ' jump on less common choice
    ! add ebx, 1
    ! jmp adst

' ====================================

  ' -----------------------------------------
  ' right trim any characters that are not
  ' decimal numbers, "0" to "9"
  ' -----------------------------------------
  trimit:
    ! sub edi, 1
  tloop:
    ! cmp BYTE PTR [edi], "0"
    ! jl albl
    ! cmp BYTE PTR [edi], "9"
    ! jg albl
    ! jmp lastbye
  albl:
    ! sub edi, 1
    ! jmp tloop

  lastbye:
    ! mov BYTE PTR [edi+1], 0

    ! sub edi, lpbuf
    ! mov FUNCTION, edi     ' return the uncompacted written length

    Exit FUNCTION

  #align 16
  StringTable:
    ! db 32,32,48,44,32,32,49,44,32,32,50,44,32,32,51,44,32,32,52,44,32,32,53,44,32,32,54,44,32,32,55,44
    ! db 32,32,56,44,32,32,57,44,32,49,48,44,32,49,49,44,32,49,50,44,32,49,51,44,32,49,52,44,32,49,53,44
    ! db 32,49,54,44,32,49,55,44,32,49,56,44,32,49,57,44,32,50,48,44,32,50,49,44,32,50,50,44,32,50,51,44
    ! db 32,50,52,44,32,50,53,44,32,50,54,44,32,50,55,44,32,50,56,44,32,50,57,44,32,51,48,44,32,51,49,44
    ! db 32,51,50,44,32,51,51,44,32,51,52,44,32,51,53,44,32,51,54,44,32,51,55,44,32,51,56,44,32,51,57,44
    ! db 32,52,48,44,32,52,49,44,32,52,50,44,32,52,51,44,32,52,52,44,32,52,53,44,32,52,54,44,32,52,55,44
    ! db 32,52,56,44,32,52,57,44,32,53,48,44,32,53,49,44,32,53,50,44,32,53,51,44,32,53,52,44,32,53,53,44
    ! db 32,53,54,44,32,53,55,44,32,53,56,44,32,53,57,44,32,54,48,44,32,54,49,44,32,54,50,44,32,54,51,44
    ! db 32,54,52,44,32,54,53,44,32,54,54,44,32,54,55,44,32,54,56,44,32,54,57,44,32,55,48,44,32,55,49,44
    ! db 32,55,50,44,32,55,51,44,32,55,52,44,32,55,53,44,32,55,54,44,32,55,55,44,32,55,56,44,32,55,57,44
    ! db 32,56,48,44,32,56,49,44,32,56,50,44,32,56,51,44,32,56,52,44,32,56,53,44,32,56,54,44,32,56,55,44
    ! db 32,56,56,44,32,56,57,44,32,57,48,44,32,57,49,44,32,57,50,44,32,57,51,44,32,57,52,44,32,57,53,44
    ! db 32,57,54,44,32,57,55,44,32,57,56,44,32,57,57,44,49,48,48,44,49,48,49,44,49,48,50,44,49,48,51,44
    ! db 49,48,52,44,49,48,53,44,49,48,54,44,49,48,55,44,49,48,56,44,49,48,57,44,49,49,48,44,49,49,49,44
    ! db 49,49,50,44,49,49,51,44,49,49,52,44,49,49,53,44,49,49,54,44,49,49,55,44,49,49,56,44,49,49,57,44
    ! db 49,50,48,44,49,50,49,44,49,50,50,44,49,50,51,44,49,50,52,44,49,50,53,44,49,50,54,44,49,50,55,44
    ! db 49,50,56,44,49,50,57,44,49,51,48,44,49,51,49,44,49,51,50,44,49,51,51,44,49,51,52,44,49,51,53,44
    ! db 49,51,54,44,49,51,55,44,49,51,56,44,49,51,57,44,49,52,48,44,49,52,49,44,49,52,50,44,49,52,51,44
    ! db 49,52,52,44,49,52,53,44,49,52,54,44,49,52,55,44,49,52,56,44,49,52,57,44,49,53,48,44,49,53,49,44
    ! db 49,53,50,44,49,53,51,44,49,53,52,44,49,53,53,44,49,53,54,44,49,53,55,44,49,53,56,44,49,53,57,44
    ! db 49,54,48,44,49,54,49,44,49,54,50,44,49,54,51,44,49,54,52,44,49,54,53,44,49,54,54,44,49,54,55,44
    ! db 49,54,56,44,49,54,57,44,49,55,48,44,49,55,49,44,49,55,50,44,49,55,51,44,49,55,52,44,49,55,53,44
    ! db 49,55,54,44,49,55,55,44,49,55,56,44,49,55,57,44,49,56,48,44,49,56,49,44,49,56,50,44,49,56,51,44
    ! db 49,56,52,44,49,56,53,44,49,56,54,44,49,56,55,44,49,56,56,44,49,56,57,44,49,57,48,44,49,57,49,44
    ! db 49,57,50,44,49,57,51,44,49,57,52,44,49,57,53,44,49,57,54,44,49,57,55,44,49,57,56,44,49,57,57,44
    ! db 50,48,48,44,50,48,49,44,50,48,50,44,50,48,51,44,50,48,52,44,50,48,53,44,50,48,54,44,50,48,55,44
    ! db 50,48,56,44,50,48,57,44,50,49,48,44,50,49,49,44,50,49,50,44,50,49,51,44,50,49,52,44,50,49,53,44
    ! db 50,49,54,44,50,49,55,44,50,49,56,44,50,49,57,44,50,50,48,44,50,50,49,44,50,50,50,44,50,50,51,44
    ! db 50,50,52,44,50,50,53,44,50,50,54,44,50,50,55,44,50,50,56,44,50,50,57,44,50,51,48,44,50,51,49,44
    ! db 50,51,50,44,50,51,51,44,50,51,52,44,50,51,53,44,50,51,54,44,50,51,55,44,50,51,56,44,50,51,57,44
    ! db 50,52,48,44,50,52,49,44,50,52,50,44,50,52,51,44,50,52,52,44,50,52,53,44,50,52,54,44,50,52,55,44
    ! db 50,52,56,44,50,52,57,44,50,53,48,44,50,53,49,44,50,53,50,44,50,53,51,44,50,53,52,44,50,53,53,44

END FUNCTION

' 

FUNCTION dbcompact(ByVal mem as DWORD) as DWORD

    #REGISTER NONE

    ! mov ecx, mem
    ! sub ecx, 1
    ! mov edx, ecx

  #align 16
  stlbl:
    ! add ecx, 1
    ! movzx eax, BYTE PTR [ecx]
    ! cmp BYTE PTR [ecx-1], "b"     ' only allow space after "db"
    ! je wrt
    ! cmp eax, 32
    ! je stlbl
  wrt:
    ! add edx, 1
    ! mov [edx], al
    ! test eax, eax
    ! jne stlbl

    ! sub edx, mem
    ! mov FUNCTION, edx             ' return compacted written length

END FUNCTION

' 