#IF 0  ' 

    Convert binary file to any of 3 PowerBASIC DB formats

    Threaded file IO
    High speed binary to DB algorithm

    Build with PBwin90

#ENDIF ' 

    #include "bin2db.inc"

' 

FUNCTION PBmain() AS LONG

    LOCAL Wid          as LONG
    LOCAL Hgt          as LONG
    LOCAL wcex         as WNDCLASSEX
    LOCAL szClassName  as ASCIIZ * 32

    global_init

    DisplayName$ = "Binary To DB Converter"
    szClassName  = "Bin_To_DB_Class"

    wcex.cbSize        = SIZEOF(wcex)
    wcex.style         = %CS_BYTEALIGNCLIENT or %CS_BYTEALIGNWINDOW
    wcex.lpfnWndProc   = CODEPTR(WndProc)
    wcex.cbClsExtra    = 0
    wcex.cbWndExtra    = 0
    wcex.hInstance     = hInstance
    wcex.hIcon         = hIcon
    wcex.hCursor       = LoadCursor(%NULL,ByVal %IDC_ARROW)
    wcex.hbrBackground = %NULL
    wcex.lpszMenuName  = %NULL
    wcex.lpszClassName = VarPtr(szClassName)
    wcex.hIconSm       = hIcon

    RegisterClassEx wcex

    Wid = Sw * .70
    Hgt = Sh * .70
    If Wid > Hgt * 1.4 Then
      Wid = Hgt * 1.4
    End If

    hWnd = CreateWindowEx( _
           %WS_EX_LEFT, _                  ' extended style
           szClassName, _                  ' window class name
           ByVal StrPtr(DisplayName$), _   ' window title
           %WS_OVERLAPPEDWINDOW, _         ' window style
           Sw\2-(Wid\2), _                 ' initial x position
           Sh\2-(Hgt\2), _                 ' initial y position
           Wid, _                          ' initial x size
           Hgt, _                          ' initial y size
           %NULL, _                        ' parent window handle
           %NULL, _                        ' window menu handle
           hInstance, _                    ' program instance handle
           ByVal %NULL)                    ' creation parameters

    hMnu = LoadMenu(hInstance,ByVal 10)
    SetMenu hWnd, hMnu

  ' -----------------------------------------------
  ' rich edit code AFTER the main window is created
  ' -----------------------------------------------
    LoadLibrary "RICHED20.DLL"
    hEdit = RichEdit(hWnd)
    SendMessage hEdit,%EM_EXLIMITTEXT,0,-1
    SendMessage hEdit,%EM_SETOPTIONS,%ECOOP_XOR,%ECO_SELECTIONBAR
    SendMessage hEdit,%WM_SETFONT,GetStockObject(%SYSTEM_FIXED_FONT),%TRUE

    ShowWindow hWnd, %SW_SHOW
    UpdateWindow hWnd

    FUNCTION = MessageLoop

END FUNCTION

' 

FUNCTION MessageLoop() as DWORD

    LOCAL pst as DWORD                                      ' DWORD pointer for structure
    LOCAL msg as MSGSTRUCT                                  ' message structure

    pst = VarPtr(msg)                                       ' get pointer address
    ! jmp nxt_msg                                           ' jump into MsgLoop

  MsgLoop:
    TranslateMessage ByVal pst
    DispatchMessage  ByVal pst
  nxt_msg:
    GetMessage ByVal pst,0,0,0
    ! test eax, eax
    ! jne MsgLoop

    FUNCTION = msg.wParam

END FUNCTION

' 

SUB global_init()

    LOCAL styl as DWORD
    LOCAL icce as INIT_COMMON_CONTROLSEX

  ' --------------------------------------
    icce.dwSize = SIZEOF(icce)                              ' set the structure size
    icce.dwICC  = %ICC_BAR_CLASSES
    InitCommonControlsEx icce                               ' initialise the common control library
  ' --------------------------------------

    hInstance = GetModuleHandle(ByVal %NULL)                ' application instance handle
    hIcon     = LoadIcon(hInstance,ByVal 2)                 ' application icon handle
    Sw        = GetSystemMetrics(%SM_CXSCREEN)              ' screen width
    Sh        = GetSystemMetrics(%SM_CYSCREEN)              ' screen height

  ' -------------------------
  ' global file filter string
  ' -------------------------
    ffilter$ = chr$("All Files",0,"*.*",0,0)
                    
END SUB

' 

FUNCTION WndProc(ByVal hWin   as DWORD, _
                 ByVal Msg    as DWORD, _
                 ByVal wParam as LONG, _
                 ByVal lParam as LONG) as DWORD

    LOCAL hDC   as DWORD
    LOCAL tbh   as DWORD
    LOCAL sbh   as DWORD
    LOCAL tID   as DWORD
    LOCAL Ps    as PAINTSTRUCT
    LOCAL Rct   as RECT
    LOCAL hThread as DWORD

    Select Case as LONG Msg

      Case %WM_SETFOCUS
        SetFocus hEdit

      Case %WM_COMMAND
        Select Case as LONG wParam
        ' -----------------
        ' Tool Bar Messages
        ' -----------------
          Case  50
            ! jmp fopenfile

          Case  51
            ! jmp fsavefile

          Case  52
            ! jmp copy_txt

          Case  56
            ! jmp exit_app

        ' -------------
        ' Menu Messages
        ' -------------
          Case 1010
          fopenfile:
            hThread = CreateThread(ByVal %NULL,4096,CodePtr(open_new_file),0,ByVal %NULL,ByVal VarPtr(tID) )
            CloseHandle hThread

          Case 1020
          fsavefile:
            hThread = CreateThread(ByVal %NULL,4096,CodePtr(save_new_file),0,ByVal %NULL,ByVal VarPtr(tID) )
            CloseHandle hThread

          Case 1090
          exit_app:
            SendMessage hWin,%WM_SYSCOMMAND,%SC_CLOSE,ByVal %NULL

          Case 1200
          copy_txt:
            Select_All hEdit

          Case 5000
            DialogBox hInstance,ByVal 200,hWnd,CodePtr(AboutProc)

        End Select

      Case %WM_CREATE
        hToolbar = Create_Tool_Bar(hInstance,hWin,24,24)
        hStatus = Create_Status_Bar(hWin)
        SendMessage hToolbar,%TB_CHECKBUTTON,53,%TRUE   ' button 53 pressed

      Case %WM_SYSCOLORCHANGE
        DestroyWindow hToolBar
        hToolbar = Create_Tool_Bar(hInstance,hWin,24,24)
        SendMessage hToolbar,%TB_CHECKBUTTON,53,%TRUE   ' button 53 pressed

      Case %WM_SIZE
        SendMessage hToolBar, %TB_AUTOSIZE,0,0
        MoveWindow hStatus,0,0,0,0,%TRUE

        GetWindowRect hToolBar,Rct                      ' get the toolbar height in pixels
        tbh = Rct.nBottom - Rct.nTop

        GetWindowRect hStatus,Rct                       ' get the status bar height in pixels
        sbh = Rct.nBottom - Rct.nTop

        GetClientRect hWin,Rct                          ' get the client rectangle dimensions

        MoveWindow hEdit,0,tbh,Rct.nRight, _            ' size client window into client area
                   Rct.nBottom - (tbh + sbh), %TRUE

      Case %WM_CLOSE

      Case %WM_DESTROY
        PostQuitMessage 0
        FUNCTION = 0
        Exit FUNCTION

    END Select

    FUNCTION = DefWindowProc(hWin,Msg,wParam,lParam)

END FUNCTION

' 

FUNCTION open_new_file(ByVal arg as DWORD) as DWORD

    LOCAL wlen as DWORD
    LOCAL slen as DWORD

    fname$ = GetFileName(hInstance,hWnd,"Open File",ffilter$,"")
    If fname$ = "" Then
      Exit FUNCTION
    End if

    tmsg$ = "Loading file "+fname$
    SendMessage hStatus,%SB_SETTEXT,1,ByVal StrPtr(tmsg$)

    Open fname$ for Binary as #1
      slen = lof(1)                             ' get the file length
      Get$ #1, slen, src$                       ' load file data into string
    Close #1

    tmsg$ = "Converting file "+fname$
    SendMessage hStatus,%SB_SETTEXT,1,ByVal StrPtr(tmsg$)

    dbdata$ = bin2db(src$)                      ' convert binary string to DB string
    wlen = len(dbdata$)                         ' get the written length if required


    barename$ = NameFromPath(fname$)
    Replace "." with "_" in barename$



    cmnt$ = "' "

  ' -------------------------------------------------------

    If SendMessage(hToolbar,%TB_GETSTATE,53,0) = 5 Then     ' basic string function

      head$ = _
        cmnt$+chr$(13,10)+_
        chr$(13,10)+_
        "  ' original file = "+fname$+" at "+ltrim$(str$(slen))+" bytes"+chr$(13,10) + _
        chr$(13,10)+_
        "FUNCTION "+barename$+"() as STRING"+chr$(13,10)+_
        chr$(13,10)+_
        "    #REGISTER NONE"+chr$(13,10)+_
        chr$(13,10)+_
        "    LOCAL pdst as DWORD"+chr$(13,10)+_
        chr$(13,10)+_
        "    dst$ = space$("+ ltrim$(str$(slen)) +")"+chr$(13,10)+_
        "    pdst = StrPtr(dst$)"+chr$(13,10)+_
        chr$(13,10)+_
        "    ! cld"+chr$(13,10)+_
        "    ! mov esi, OFFSET bindata"+chr$(13,10)+_
        "    ! mov edi, pdst"+chr$(13,10)+_
        "    ! mov ecx, " + ltrim$(str$(slen)) + chr$(13,10)+_
        "    ! rep movsb"+chr$(13,10)+_
        chr$(13,10)+_
        "    FUNCTION = dst$"+chr$(13,10)+_
        "    Exit FUNCTION"+chr$(13,10)+_
        chr$(13,10)+_
        "  #align 16"+chr$(13,10)+_
        "  bindata:"

        lf2$ = chr$(13,10,13,10)
        tail$ = lf2$ + cmnt$
        rslt$ = build$(head$,dbdata$,lf2$,"END FUNCTION",tail$)
        SetWindowText hEdit,ByVal StrPtr(rslt$)

        tmsg$ = "Converted file "+fname$+ " loaded at" + str$(len(rslt$)) + " bytes"
        SendMessage hStatus,%SB_SETTEXT,1,ByVal StrPtr(tmsg$)

      Exit FUNCTION
    End If

  ' -------------------------------------------------------

    If SendMessage(hToolbar,%TB_GETSTATE,54,0) = 5 Then     ' return data pointer function

      head$ = _
        cmnt$+chr$(13,10)+_
        chr$(13,10)+_
        "  ' original file = "+fname$+" at "+ltrim$(str$(slen))+" bytes"+chr$(13,10) + _
        chr$(13,10) + _
        "FUNCTION "+barename$+"(ByVal arg as DWORD) as DWORD"+chr$(13,10)+_
        chr$(13,10)+_
        "    If arg = 0 Then ' ------------------ call function with 0 to get pointer to data"+chr$(13,10)+_
        "      FUNCTION = CodePtr(bindata)"+chr$(13,10)+_
        "      Exit FUNCTION"+chr$(13,10)+_
        "    Else            ' ------------------ call function with non-zero to get data length"+chr$(13,10)+_
        "      FUNCTION = "+ltrim$(str$(slen))+chr$(13,10)+_
        "      Exit FUNCTION"+chr$(13,10)+_
        "    End If"+chr$(13,10)+_
        chr$(13,10)+_
        "  #align 16"+chr$(13,10)+_
        "  bindata:"

        lf2$ = chr$(13,10,13,10)
        tail$ = lf2$ + cmnt$
        rslt$ = build$(head$,dbdata$,lf2$,"END FUNCTION",tail$)
        SetWindowText hEdit,ByVal StrPtr(rslt$)

        tmsg$ = "Converted file "+fname$+ " loaded at" + str$(len(rslt$)) + " bytes"
        SendMessage hStatus,%SB_SETTEXT,1,ByVal StrPtr(tmsg$)

      Exit FUNCTION
    End If

  ' -------------------------------------------------------

    If SendMessage(hToolbar,%TB_GETSTATE,55,0) = 5 Then     ' write raw DB data

      head$ = chr$(13,10) + "  ' original file = "+fname$+" at "+ltrim$(str$(slen))+" bytes"+chr$(13,10)
        rslt$ = build$(head$,dbdata$)
        SetWindowText hEdit,ByVal StrPtr(rslt$)

        tmsg$ = "Converted file "+fname$+ " loaded at" + str$(len(rslt$)) + " bytes"
        SendMessage hStatus,%SB_SETTEXT,1,ByVal StrPtr(tmsg$)

      Exit FUNCTION
    End If

  ' -------------------------------------------------------

    FUNCTION = 0

END FUNCTION

' 

FUNCTION save_new_file(ByVal arg as DWORD) as DWORD

    LOCAL hFile as DWORD
    LOCAL ofs   as OFSTRUCT
    LOCAL es    as EDITSTREAM
    LOCAL wtl   as DWORD

    fname$ = SaveFileName(hInstance,hWnd,"Save File As ...",ffilter$,"")
    If fname$ = "" Then
      Exit FUNCTION
    End if

    hFile = OpenFile(ByCopy fname$,ByVal VarPtr(ofs),%OF_CREATE)
      es.dwCookie    = hFile
      es.dwError     = 0
      es.pfnCallback = CodePtr(sfCallBack)
    SendMessage hEdit,%EM_STREAMOUT,%SF_TEXT,ByVal VarPtr(es)
    CloseHandle hFile

    wtl = GetWindowTextLength(hEdit)

    tmsg$ = fname$+ " written to disk at" + str$(wtl) + " bytes"
    SendMessage hStatus,%SB_SETTEXT,1,ByVal StrPtr(tmsg$)

    FUNCTION = 0

END FUNCTION

' 

FUNCTION Create_Status_Bar(hParent as DWORD) as DWORD

    LOCAL hndl as DWORD
    dim sbParts(1) as LONG

    hndl = CreateStatusWindow(%WS_CHILD or %WS_VISIBLE or _
                              %SBS_SIZEGRIP,ByVal %NULL,hParent, 200)

    sbParts(0) =  120
    sbParts(1) =  -1

    SendMessage hndl,%SB_SETPARTS, 2,ByVal VarPtr(sbParts(0))

    FUNCTION = hndl

END FUNCTION

' 

FUNCTION AboutProc( _
                  ByVal hDlg   as DWORD, _
                  ByVal Msg    as DWORD, _
                  ByVal wParam as LONG, _
                  ByVal lParam as LONG) as DWORD

    Select Case as LONG Msg
      Case %WM_INITDIALOG

        SetWindowText hDlg,"  About Binary To DB Converter"

        SetWindowText(GetDlgItem(hDlg,65000),"A tool for creating DB data in a multiple formats")
        SetWindowText(GetDlgItem(hDlg,65001),"Binary To DB Converter Copyright (c) 1998-2009")
        SetWindowText(GetDlgItem(hDlg,65002),"Steve Hutchesson hutch@movsd.com"+chr$(13,10)+"All Rights Reserved")

        Advertise$ = "DB data in 3 output formats," + chr$(13,10,13,10) + _
                     "1.  Basic dynamic string function" + chr$(13,10) + _
                     "2.  Function returns pointer to DB data" + chr$(13,10) + _
                     "3.  Raw DB format data output"

        SetWindowText(GetDlgItem(hDlg,65003),ByVal StrPtr(Advertise$))

      Case %WM_COMMAND
        Select Case wParam
          case 1000
          ! jmp outa_here
        End Select

      Case %WM_SYSCOMMAND
        Select Case wParam
          Case %SC_CLOSE
        outa_here:
          EndDialog hDlg, 0
        End Select

    End Select

    FUNCTION = 0

END FUNCTION

' 

FUNCTION RichEdit(hParent as LONG) as DWORD

    FUNCTION = CreateWindowEx(0,"RichEdit20A",ByVal %NULL, _
               %WS_VISIBLE or %WS_CHILDWINDOW or  _
               %ES_MULTILINE or %WS_VSCROLL or %WS_HSCROLL or _
               %ES_AUTOHSCROLL or %ES_AUTOVSCROLL or %ES_NOHIDESEL or _
               %WS_CLIPSIBLINGS, _
               0,0,100,50,hParent,0,hInstance,ByVal %NULL)

END FUNCTION

' 

SUB Select_All(ByVal Edit as LONG)

    LOCAL Cr as CHARRANGE

    Cr.cpMin = 0
    Cr.cpMax = GetWindowTextLength(Edit) + 1

    SendMessage Edit,%EM_EXSETSEL,0,ByVal VarPtr(Cr)

    SendMessage hEdit,%WM_COPY,0,0

End SUB

' 

FUNCTION sfCallBack(ByVal dwCookie as LONG, ByVal pbBuff as LONG, _
                    ByVal cb as LONG,ByVal pcb as LONG PTR) as LONG

    rv& = WriteFile(dwCookie,ByVal pbBuff,cb,@pcb,ByVal %NULL)

    FUNCTION = 0

END FUNCTION

' 

FUNCTION NameFromPath(fname$) as STRING

    #REGISTER NONE

    LOCAL var as LONG
    LOCAL ln  as LONG

    ln  = len(fname$)
    ! mov esi, fname$
    ! mov esi, [esi]    ; dereference ESI

    ! xor ecx, ecx      ; zero ECX to use as location counter
    ! mov edx, ln
    ! add edx, esi      ; exit test condition in EDX

  lbl1:
    ! mov al, [esi]     ; character in AL for comparison
    ! inc esi           ; increment pointer
    ! inc ecx           ; increment location counter
    ! cmp al, "\"
    ! je nxt1
    ! cmp al, "/"
    ! je nxt1
    ! cmp edx, esi
    ! jne lbl1
    ! jmp qit

  nxt1:
    ! mov edi, ecx      ; put each "\" position in EDI
    ! cmp edx, esi
    ! jne lbl1

  qit:
    ! sub ln, edi       ; sub last "\" position from length of string

    FUNCTION = right$(fname$,ln)

END FUNCTION

' 


