#IF 0  ' 

    The structure, messages and API functions have been renamed so they don't
    conflict with their equivalents in the common dialog include file.

    You avoid extra dynamic code from the common dialog include file if you need any of
    its other functionality by using the exclusion equate below.
     
    %NOFILEDLG = 1

#ENDIF ' 

    TYPE OFST
      lStructSize          as DWORD
      hwndOwner            as DWORD
      hInstance            as DWORD
      lpstrFilter          as DWORD
      lpstrCustomFilter    as DWORD
      nMaxCustFilter       as DWORD
      nFilterIndex         as DWORD
      lpstrFile            as DWORD
      nMaxFile             as DWORD
      lpstrFileTitle       as DWORD
      nMaxFileTitle        as DWORD
      lpstrInitialDir      as DWORD
      lpstrTitle           as DWORD
      Flags                as DWORD
      nFileOffset          as WORD
      nFileExtension       as WORD
      lpstrDefExt          as DWORD
      lCustData            as DWORD
      lpfnHook             as DWORD
      lpTemplateName       as DWORD
    END TYPE

    MACRO OFN_EXPLORER      = &H00080000
    MACRO OFN_FILEMUSTEXIST = &H00001000
    MACRO OFN_LONGNAMES     = &H00200000
    MACRO OFN_HIDEREADONLY  = &H00000004
    MACRO OFN_OVERWRITEPROMPT = &H00000002

    DECLARE FUNCTION OpenDlg LIB "COMDLG32.DLL" _
                     ALIAS "GetOpenFileNameA"(lpofn AS OFST) AS LONG
    DECLARE FUNCTION SaveDlg LIB "COMDLG32.DLL" _
                     ALIAS "GetSaveFileNameA"(lpofn AS OFST) AS LONG

' 

FUNCTION GetFileName(ByVal iinstance as DWORD, _
                     ByVal hParent   as DWORD, _
                     dlgtitle$,filefilter$,startdir$) as STRING

    LOCAL pfilter as DWORD
    LOCAL ptitle  as DWORD
    LOCAL pbuffer as DWORD
    LOCAL pcurdir as DWORD
    LOCAL ofn  as OFST
    LOCAL szbuffer as ASCIIZ * %MAX_PATH

    pfilter = StrPtr(filefilter$)
    ptitle  = StrPtr(dlgtitle$)
    pbuffer = VarPtr(szbuffer)

    If startdir$ = "" Then
      startdir$ = string$(%MAX_PATH,0)
      pcurdir = StrPtr(startdir$)
      GetCurrentDirectory %MAX_PATH,ByVal pcurdir
    Else
      pcurdir = StrPtr(startdir$)
    End If

    ofn.lStructSize     = SIZEOF(OFST)
    ofn.hWndOwner       = hParent
    ofn.hInstance       = iinstance
    ofn.lpstrFilter     = pfilter
    ofn.lpstrFile       = pbuffer
    ofn.nMaxFile        = %MAX_PATH
    ofn.lpstrTitle      = ptitle
    ofn.lpstrInitialDir = pcurdir
    ofn.Flags           = OFN_EXPLORER or OFN_FILEMUSTEXIST or _
                          OFN_LONGNAMES or OFN_HIDEREADONLY

    If OpenDlg(ofn) = 0 Then
      FUNCTION = ""               ' return a NULL string if cancelled
    Else
      buffer$ = szbuffer          ' truncate the szString without extra basic string functions
      FUNCTION = buffer$          ' return the selected path
    End If

End FUNCTION

' 

FUNCTION SaveFileName(ByVal iinstance as DWORD, _
                      ByVal hParent   as DWORD, _
                      dlgtitle$,filefilter$,startdir$) as STRING

    LOCAL pfilter as DWORD
    LOCAL ptitle  as DWORD
    LOCAL pbuffer as DWORD
    LOCAL pcurdir as DWORD
    LOCAL ofn  as OFST
    LOCAL szbuffer as ASCIIZ * %MAX_PATH

    pfilter = StrPtr(filefilter$)
    ptitle  = StrPtr(dlgtitle$)
    pbuffer = VarPtr(szbuffer)

    If startdir$ = "" Then
      startdir$ = string$(%MAX_PATH,0)
      pcurdir = StrPtr(startdir$)
      GetCurrentDirectory %MAX_PATH,ByVal pcurdir
    Else
      pcurdir = StrPtr(startdir$)
    End If

    ofn.lStructSize     = SIZEOF(OFST)
    ofn.hWndOwner       = hParent
    ofn.hInstance       = iinstance
    ofn.lpstrFilter     = pfilter
    ofn.lpstrFile       = pbuffer
    ofn.nMaxFile        = %MAX_PATH
    ofn.lpstrTitle      = ptitle
    ofn.lpstrInitialDir = pcurdir
    ofn.Flags           = OFN_EXPLORER or OFN_LONGNAMES or OFN_HIDEREADONLY or OFN_OVERWRITEPROMPT

    If SaveDlg(ofn) = 0 Then
      FUNCTION = ""               ' return a NULL string if cancelled
    Else
      buffer$ = szbuffer          ' truncate the szString without extra basic string functions
      FUNCTION = buffer$          ' return the selected path
    End If

End FUNCTION

' 
